SystemOrganization addCategory: #'MC2-Repository-Directory'!

MDRepository subclass: #MDDirectoryRepository
	instanceVariableNames: 'name directory primary secondary nameOfPrimary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Repository-Directory'!

!MDDirectoryRepository class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:55'!
forTesting
	^ self named: 'TestDirectoryRepository'! !

!MDDirectoryRepository class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:40'!
id: aHashstamp name: aString
	^ self 	
		id: aHashstamp 
		name: aString 
		directory: (FileDirectory default directoryNamed: aString)! !

!MDDirectoryRepository class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:32'!
id: aHashstamp name: aString directory: aDirectory
	^ self basicNew initializeWithId: aHashstamp name: aString directory: aDirectory! !

!MDDirectoryRepository class methodsFor: 'instance creation' stamp: 'cwp 1/18/2010 21:34'!
name: aString directory: aDirectory
	^ self id: MDHashstamp new name: aString directory: aDirectory! !

!MDDirectoryRepository class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 19:10'!
named: aString
	^ self name: aString directory: (FileDirectory default directoryNamed: aString)! !

!MDDirectoryRepository class methodsFor: 'instance creation' stamp: 'jf 11/8/2009 19:10'!
on: aDirectory
	^ self name: aDirectory localName directory: aDirectory! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:25'!
addFileNamed: aString
	| stream |
	stream := directory oldFileNamed: aString.
	secondary add: (MDFileRepository on: stream)! !

!MDDirectoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/21/2008 20:13'!
allHashstamps
	| hashstamps |
	self scanDirectory.
	hashstamps := primary allHashstamps asSet.
	secondary do: [:ea | hashstamps addAll: ea allHashstamps].
	^ hashstamps! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'jf 10/25/2008 13:30'!
close
	super close.
	primary isNil ifFalse: [primary close].
	secondary isNil ifFalse: [secondary do: [:each | each close]]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 11/23/2008 13:13'!
createDirectory
	directory assureExistence.
	self setPrimary: (MDFileRepository on: (directory newFileNamed: self primaryFilename)).! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:18'!
description
	^ self name, '/', self primaryName! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 10/22/2009 12:13'!
destroy
	super destroy.
	directory recursiveDelete! !

!MDDirectoryRepository methodsFor: 'converting' stamp: 'cwp 10/17/2009 23:21'!
elementClass
	^ MDDirectoryRepositoryElement! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:10'!
entryIsSecondary: entry 
	^ entry isDirectory not 
		and: [ (entry name endsWith: '.mcr') 
			and: [ entry name ~= primary name ] ]! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/21/2008 20:19'!
fileNames
	^ directory entries 
		inject: Set new
		into: 
			[ :set :entry | 
			(self entryIsSecondary: entry) ifTrue: [set add: entry name].
			set ].
	! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/21/2008 20:12'!
get: aHashstamp
	^ (primary get: aHashstamp) ifNil:
		[self scanDirectory.
		secondary do: [:ea | (ea get: aHashstamp) ifNotNilDo: [:obj | ^ obj]].
		nil]! !

!MDDirectoryRepository methodsFor: 'testing' stamp: 'cwp 4/21/2009 14:25'!
hasPrimaryName
	^ nameOfPrimary notNil! !

!MDDirectoryRepository methodsFor: 'synchronization' stamp: 'cwp 8/21/2008 20:13'!
includes: aHashstamp
	^ (primary includes: aHashstamp) or: 
		[self scanDirectory.
		secondary anySatisfy: [:ea | ea includes: aHashstamp]]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 11/23/2008 13:08'!
initFiles
	secondary := Set new.
	directory exists 
		ifTrue: 
			[self openPrimary. 
			self scanDirectory]
		ifFalse: 
			[self createDirectory]
! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'cwp 1/18/2010 21:33'!
initializeWithId: aHashstamp name: aString directory: aDirectory
	self initializeWithId: aHashstamp.
	name := aString.
	directory := aDirectory.
	self initFiles! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/21/2008 20:12'!
memos
	| memos |
	memos := primary memos.
	self scanDirectory.
	secondary do: [:ea | memos addAll: ea memos].
	^ memos! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:17'!
name
	^ name! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 10/18/2009 21:48'!
name: aString
	name := aString! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 11/23/2008 13:14'!
openPrimary
	| filename |
	filename := self primaryFilename.
	self setPrimary: (MDFileRepository on: (directory fileNamed: filename)). ! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 13:13'!
primaryFilename
	^ self primaryName, '.mcr'! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:21'!
primaryName
	^ nameOfPrimary ifNil:
		[MDPlatform current initials]! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:24'!
primaryName: aString
	nameOfPrimary := aString! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 15:57'!
properties: properties
	| changed |
	changed := self updateName: properties name.
	changed := changed | (self updatePrimaryName: properties primaryName).
	changed ifTrue: [self initFiles].! !

!MDDirectoryRepository methodsFor: 'public' stamp: 'cwp 8/17/2008 22:41'!
put: anObject
	primary put: anObject! !

!MDDirectoryRepository methodsFor: 'private' stamp: 'cwp 8/20/2008 22:19'!
scanDirectory
	| filenames reponames |
	filenames := self fileNames.
	reponames := secondary collect: [ :ea | ea name ].
	filenames do: [ :ea | (reponames includes: ea) ifFalse: [ self addFileNamed: ea ] ].
	secondary removeAllSuchThat: [ :ea | (filenames includes: ea name) not ]! !

!MDDirectoryRepository methodsFor: 'initialize-release' stamp: 'jf 10/25/2008 13:28'!
setPrimary: aFileRepository
	primary isNil ifFalse: [primary close].
	primary := aFileRepository! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:17'!
update: properties
	super update: properties.
	properties primaryName: self primaryName.
	^ properties! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 11/23/2008 15:40'!
updateName: newName
	| parent |
	name = newName ifTrue: [^ false].
	directory 
		ifNil: [parent := FileDirectory default]
		ifNotNil: 
			[self close.
			parent := directory containingDirectory.
			parent rename: name toBe: newName].
	name := newName.
	directory := parent directoryNamed: name.
	^ true! !

!MDDirectoryRepository methodsFor: 'accessing' stamp: 'cwp 4/21/2009 14:22'!
updatePrimaryName: aString
	nameOfPrimary = aString ifTrue: [^ false].
	nameOfPrimary := aString.
	^ true! !
